#!/bin/false

depend_on(){
	! command -v "$1" >/dev/null \
		&& printf "Missing %s.\n" "$1" 1>&2 \
		&& exit 1 \
		|| true
}

fetch_upstream(){
	url="$1"
	scheme="$(scheme_from_uri "$url")"
	case "$scheme" in
	git)
		depend_on git
		git clone "$url"
		;;
	*)
		printf "%s: Invalid upstream URL %s (scheme is %s)\n" \
		       "$argv0"                 "$1"          "$scheme"
		exit 1
	esac
}

depend_on cut

scheme_from_uri(){
	# There are no colons in scheme names and no ways to separate schemes
	# from scheme-specific content without colons (RFC 3986).
	printf "%s\n" "$1" | cut -d ':' -f 1
}
